// GetScreenshot.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "GetScreenshot.h"

#include "NScreenshot.h"

#define		_ABOUT_TEXT		L"Screenshot sample\r\n 2013 NAlek\r\n\r\nWeb: http://www.nalek.org\r\nE-mail: nalek@nalek.org"
#define		_ABOUT_TITLE	L"GetScreenshot"

// Global Variables:

// Message handler for about box.
INT_PTR CALLBACK DlgAboutProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		::SetWindowText( hDlg, _ABOUT_TITLE );
		::SendDlgItemMessage( hDlg, IDC_DLG_ABOUT_EDT1, WM_SETTEXT, 0, (LPARAM) _ABOUT_TEXT );
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	if( DialogBoxParam( hInstance, MAKEINTRESOURCE(IDD_DLG_ABOUT), NULL, DlgAboutProc, NULL) ==IDOK )
	{
		CNScreenshot m_screen;

		void *pBuffer =NULL;
		unsigned long ulSize =0;
		ULONG lQuality =50;

		if( m_screen.TakeScreenshot( &pBuffer, &ulSize, lQuality, L"image/jpeg") )
		{
			//Save Dialog
			OPENFILENAME fdSave;
			TCHAR szSaveFileName[MAX_PATH] ={0};
			memset(&fdSave, 0, sizeof(OPENFILENAME));
			fdSave.lStructSize= sizeof(OPENFILENAME);
			fdSave.hwndOwner = NULL;
			fdSave.lpstrFilter = L"JPEG (*.jpg)\0*.jpg\0All Files (*.*)\0*.*\0";
			fdSave.lpstrFile = szSaveFileName;
			fdSave.nMaxFile = MAX_PATH;
			fdSave.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY |OFN_OVERWRITEPROMPT;
			fdSave.lpstrDefExt = L"jpg";

			if( GetSaveFileName(&fdSave) )
			{
				DWORD dwWritten;
				HANDLE hFile =::CreateFile( fdSave.lpstrFile, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );

				if( (hFile ==INVALID_HANDLE_VALUE) || !::WriteFile( hFile, pBuffer, ulSize, &dwWritten, NULL ) )
					MessageBox( NULL, L"Save error", NULL, MB_ICONSTOP );

				if( hFile !=INVALID_HANDLE_VALUE )
					::CloseHandle( hFile );

				free( pBuffer);
			}
		}
	}
	return 0;
}
